// Author : Nicolas JEAN
// Date   : October 2002
// filename : arithm.c
// Copyright : Nicolas JEAN 2001 - 2004
// available on http://youpee.salemioche.com

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "youpee.h"
#include "common.h"
#include "define.h"
#include "arithm.h"

long ar_do_plus (long l1, long l2 ) { return l1+l2; }
long ar_do_moins(long l1, long l2 ) { return l1-l2; }
long ar_do_fois (long l1, long l2 ) { return l1*l2; }
long ar_do_divis(long l1, long l2 ) { return l1/l2; }

struct { char *s;
         long (*f)(long l1, long l2); }
       op[] = { { DIESE_PLUS  , ar_do_plus  },
                { DIESE_MOINS , ar_do_moins },
                { DIESE_FOIS  , ar_do_fois  },
                { DIESE_DIVIS , ar_do_divis } };

int  get_long(char *field, int pos, long *l) {
char *p;
    *l = strtol(get_field(field, pos), &p, 10);
    if ( p[0] ) {
      process_line_eval(get_fieldpos(field,pos));
      *l = strtol(get_field(field, pos), &p, 10);
    }
    if ( p[0] ) return FALSE;
    else return TRUE;
}

long do_mop(char *field, long (*f)(long l1, long l2)) {
long l1, l2;

  if (  get_long(field, 2, &l1) ) 
    if (  get_long(field, 3, &l2) ) 
      return f(l1,l2);
  return 0;
}

char *do_arithm(char *field, long (*f)(long l1, long l2)){
char res[25];

  sprintf(res,"%ld",do_mop(field, f));
  return strdup(res);
}

char *do_plus(char *field)  { return do_arithm(field, ar_do_plus);  }
char *do_moins(char *field) { return do_arithm(field, ar_do_moins); }
char *do_fois(char *field)  { return do_arithm(field, ar_do_fois);  }
char *do_divis(char *field) { return do_arithm(field, ar_do_divis); }

void do_let(FILE *in, FILE *out, char *line){
  process_line_eval(get_fieldpos(line,3));
  add_bindefine(in, out, line);
}
