// Author : Nicolas JEAN
// Date   : October 2001
// filename : include.c
// Copyright : Nicolas JEAN 2001 - 2004
// available on http://youpee.salemioche.com

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "youpee.h"
#include "include.h"
#include "define.h"
#include "common.h"


void do_include(FILE *in, FILE *out, char *line)
{
FILE *newin;
char *filepath, *filename, *section;
char sectiontag[255], sectionendtag[255];
char buf[MAX_LINE_LENGTH];
char hasSection = 0;

    filename = get_field(line, 2);
    if ( !filename ) return;
    if ( strcmp(((section=get_field(line,3))?section:""),DIESE_ENDINCLUDE) ) {  // we just want one section
      sprintf(sectiontag,DIESE_SECTION,section);
      sprintf(sectionendtag,DIESE_ENDSECTION,section);
      hasSection = 1;
    } else {
      if ( filename[strlen(filename)-1] == '/' )
        filename[strlen(filename)-1] = 0x00;
    }
    filepath = findPath(filename, getenv(ENV_INCLUDEPATH));
    newin = fopen(filepath,"r");
    if ( ! newin ) {
      fprintf(stderr, __FILE__ ".%d: can't open file %s\n",__LINE__,filepath);
      return;
    }
    SHOW_DEP(filepath);
    replace_builtin_define(CUR_PATH,find_filepath(filepath));
    if (!hasSection) 
      process_file(newin, out, NULL);
    else {
      while ( getstrline(buf, MAX_LINE_LENGTH, newin) != NULL ) 
        if ( ! strncmp_sol(buf,sectiontag) ) break;
      process_file(newin, out, sectionendtag);
    }
    free(filepath);
    free(filename);
}


void do_includedefine(FILE *in, FILE *out, char *line)
{
FILE *newin;
char *filepath, *filename, buf[MAX_LINE_LENGTH] ;
char *section = "", *key, *value, sk[255];

    filename = get_field(line, 2);
    if ( !filename ) return;
    if ( filename[strlen(filename)-1] == '/' )
      filename[strlen(filename)-1] = 0x00;
    filepath = findPath(filename, getenv(ENV_INCLUDEPATH));
    newin = fopen(filepath,"r");
    if ( ! newin ) {
      fprintf(stderr, __FILE__ ".%d: can't open file %s\n",__LINE__,filepath);
      return;
    }
    SHOW_DEP(filepath);
    while ( getstrline(buf, MAX_LINE_LENGTH, newin) != NULL ) {
      if ( !strncmp(buf ,"@@ ",3) ) {
        section = get_field(buf,2);
        continue;
      }
      if ( ( key = get_field(buf,1) )   && strlen(key) &&
           ( value = get_field(buf,2) ) && strlen(value) ) {
        sprintf(sk,DEF_KEY_TAG,section,key);
        add_builtin_define(strdup(sk),value);
      }

    }
    fclose(newin);
    free(filepath);
    free(filename);
}
