// Author : Nicolas JEAN
// Date   : Juin 2002
// filename : regexp.c
// Copyright : Nicolas JEAN 2001 - 2004
// available on http://youpee.salemioche.com

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "common.h"
#include "regexp.h"

regexp *regexps = NULL;
int reg_lg = 0;
int reg_nb = 0;

void add_regexp(FILE *in, FILE *out, char *line) {
char *from = get_field(line, 2), *to = get_field(line, 3);
const char *error;
int errorNb;
  if (!from) return;
  if ( reg_nb >= reg_lg ) regexps = (regexp *) realloc(regexps, ( reg_lg += 50 ) * sizeof(regexp) );
  
  regexps[reg_nb].pattern = from;  
  regexps[reg_nb].re = pcre_compile(from, 0, &error, &errorNb, NULL);
  regexps[reg_nb].from = pcre_study(regexps[reg_nb].re,0,&error) ;
  regexps[reg_nb].to = to;

  regexps[++reg_nb].re = NULL;
}

int replace_regexp(char *line, regexp r) {
char buf[MAX_LINE_LENGTH];
char to[MAX_LINE_LENGTH];
char ssnb[8], *ss;
int rc;
int ovector[MAX_NUMBER_SUBSTRING];
  if ( ! line ) return 0;
  rc = pcre_exec(r.re, r.from, line, strlen(line), 0, 0, ovector,
                                                   MAX_NUMBER_SUBSTRING);
  if ( rc > 0 ) {
    int i, lg;
    strncpy(buf,line, ovector[0]); buf[ovector[0]] = 0x00;
    strcpy(to, r.to);
    for ( i=0; i < rc ; i++ ) {
      sprintf(ssnb, REGEXP_SUBSTRING, i);
      ss = malloc(((lg = ovector[2*i+1]-ovector[2*i] ) +1)*sizeof(char));
      strncpy(ss, &line[ ovector[2*i] ], lg); ss[lg] = 0x00;
      replace_string(to, ssnb, ss);
      free(ss);
    }
    strcat(buf,to);
    rc = strlen(buf);
    strcat(buf,&line[ovector[1]]);
    strcpy(line, buf);
    return rc;
  }     
  return 0 ;
}

int do_regexp ( char *line ){
int offset=0, start=0;
regexp *d = regexps;
  if ( ! d ) return 0;
  while ( d->re ) {
    while ( ( offset = replace_regexp(&line[start], *d) ) ) start +=offset;
    d++; offset = start = 0;
  }
  return 1;
}


